#!/bin/bash -e

# config
export ANDROID_ROOT=/home/android/ics/

# initialization
cd $ANDROID_ROOT
source build/envsetup.sh
lunch full_beagleboard_xm-eng

# build android
time make -j8

# prepare rootfs
cd $ANDROID_ROOT/out/target/product/beagleboard_xm/
rm -rf rootfs
mkdir rootfs
sudo cp -a ./root/* ./rootfs/
sudo cp -a ./system/* ./rootfs/system/

# build kernel
export ARCH=arm
export CROSS_COMPILE=$ANDROID_ROOT/prebuilt/linux-x86/toolchain/arm-eabi-4.4.3/bin/arm-eabi-
cd $ANDROID_ROOT/board/beagleboard/kernel
#make clean
make omap3_beagle_android_vcnl4020_defconfig
make uImage modules -j8

# partition and format sd-card
sudo umount /dev/sdd || true
sudo umount /dev/sdd1 || true
sudo umount /dev/sdd2 || true
sudo umount /dev/sdd3 || true

# partition werden angelegt
cd $ANDROID_ROOT/board/beagleboard/sdcard
sudo LANG=C ./mksdcard_beagle.sh /dev/sdd

# der bootsector bzw grub wird configuriert
cd $ANDROID_ROOT/board/beagleboard/bootscript
./mkbootscr

# copy data to sd-card and umount
echo -n "Confirm that SD card is mounted by pressing any key..."
read confirmation

cd $ANDROID_ROOT
sudo cp -a board/beagleboard/x-loader/MLO /media/boot/
sudo cp -a board/beagleboard/u-boot/u-boot.bin /media/boot/
sudo cp -a board/beagleboard/bootscript/boot.scr /media/boot/
sudo cp -a board/beagleboard/kernel/arch/arm/boot/uImage /media/boot/
cd $ANDROID_ROOT/out/target/product/beagleboard_xm/
sudo cp -a ./rootfs/* /media/rootfs/
sudo cp $ANDROID_ROOT/VCNL40x0-DemoApp.apk /media/rootfs/system/app/
sudo chmod 777 -R /media/rootfs

sudo umount /dev/sdd1
sudo umount /dev/sdd2
sudo umount /dev/sdd3
echo -n "DONE"

