/**
 * www.sic-software.com
 * @file MainActivity.java
 * @date 21.06.2012
 * @author fl
 * @brief See Javadoc for this class
 */
package com.sic.vishay.vcnl40x0.demo;

import android.app.KeyguardManager;
import android.app.KeyguardManager.KeyguardLock;
import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.TabHost;
import android.widget.TabHost.TabSpec;

/**
 * The main activity of this application, which provides the functionality in a tab bar.
 */
public class MainActivity extends TabActivity {
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        KeyguardManager keyguardManager = (KeyguardManager) getSystemService(KEYGUARD_SERVICE);
        KeyguardLock keyguardLock = keyguardManager.newKeyguardLock(MainActivity.class.getName());
        keyguardLock.disableKeyguard();
        
        TabHost tabHost = getTabHost();
        
        // Tab for Proximity sensor
        TabSpec proximitySpec = tabHost.newTabSpec("Proximity");
        proximitySpec.setIndicator("Proximity");
        Intent proximityIntent = new Intent(this, ProximityActivity.class);
        proximitySpec.setContent(proximityIntent);
 
        // Tab for Light sensor
        TabSpec lightSpec = tabHost.newTabSpec("Ambient Light");
        lightSpec.setIndicator("Ambient Light");
        Intent lightIntent = new Intent(this, LightActivity.class);
        lightSpec.setContent(lightIntent);
        
        // Tab for data input
        TabSpec dataSpec = tabHost.newTabSpec("LocalFile");
        dataSpec.setIndicator("LocalFile");
        Intent dataIntent = new Intent(this, ReadFileActivity.class);
        dataSpec.setContent(dataIntent);
        
        
        tabHost.addTab(proximitySpec);
        tabHost.addTab(lightSpec);
        tabHost.addTab(dataSpec);
    }
    
}