/**
 * www.sic-software.com
 * @file ReadFileActivity.java
 * @date 21.06.2012
 * @author fl
 * @brief See Javadoc for this class
 */
package com.sic.vishay.vcnl40x0.demo;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.StrictMode;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

/**
 * Displays debugging information that is written from our sensor's kernel module.
 */
public class ReadFileActivity extends Activity {
	
	protected final String TAG = getClass().getName();
	
	protected TextView mReadFile;
	protected String line;
	protected Button btn_refresh;
	protected Handler mHandler = new Handler();
	protected boolean refreshMode = false;
	protected String testPath = "data/data/com.sic.vishay.vcnl40x0.demo/status.txt";
	protected String statusPath = "/sys/devices/platform/omap/omap_i2c.2/i2c-2/2-0013/vcnl4020/status";
	protected String proxInputPath = "/sys/devices/platform/omap/omap_i2c.2/i2c-2/2-0013/vcnl4020/prox_input";
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.readfile);
		
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()
		.permitDiskReads()
		.permitDiskWrites()
		.build());
		
		mReadFile = (TextView) findViewById(R.id.tv_readFile);
		btn_refresh = (Button) findViewById(R.id.btn_refresh);
		
		mReadFile.setMovementMethod(new ScrollingMovementMethod());
		
		
		mReadFile.setText(readFile(statusPath));
		
	}
	
	@Override
	protected void onResume() {
		mReadFile.setText(readFile(statusPath));
		super.onResume();
	}
	
	public void refreshFile(View view){
//		Log.i(TAG,"Refresh");
		refreshMode = !refreshMode;
		
		if(refreshMode){
			btn_refresh.setText(getString(R.string.btn_refresh_on));
			new autoUpdater().execute(statusPath);
		}else{
			btn_refresh.setText(getString(R.string.btn_refresh));
		}
		
	}
	
	public void resetFile(View view){
		try {
			File file = new File(proxInputPath);
			file.createNewFile();
			FileOutputStream fOut = new FileOutputStream(file);
			fOut.write("0\0".getBytes());
			fOut.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	protected String readFile(String file){
		
		String res = null;
		
		try {
		 
		       InputStream in = new FileInputStream(file);
		 
		       if (in != null) {
		        // prepare the file for reading
		         InputStreamReader input = new InputStreamReader(in);
		         BufferedReader buffreader = new BufferedReader(input);
		 
		          res = "";
		          while (( line = buffreader.readLine()) != null) {
		            res += line + "\n";
		          }
		          in.close();
		          }
		 
		} catch(Exception e){
			e.printStackTrace();
		}
		return res;
	}
		
	class autoUpdater extends AsyncTask<String, Object, String>{

		@Override
		protected String doInBackground(String... params) {
			String res = null;
			
			try {
			 
			       InputStream in = new FileInputStream(params[0]);
			 
			       if (in != null) {
			        // prepare the file for reading
			         InputStreamReader input = new InputStreamReader(in);
			         BufferedReader buffreader = new BufferedReader(input);
			 
			          res = "";
			          while (( line = buffreader.readLine()) != null) {
			            res += line + "\n";
			          }
			          in.close();
			          }
			 
			} catch(Exception e){
				e.printStackTrace();
			}
			return res;
		}
		
		@Override
		protected void onPostExecute(String result) {
			mReadFile.setText(result);
			if(refreshMode){
				new autoUpdater().execute(statusPath);
			}
			
			super.onPostExecute(result);
		}
		
	}
	
}
